unit CFXOCX2;

interface

{ Notification Codes }
Const CCC_SERIE = 0;
Const CCC_SERIEBK = 1;
Const CCC_ONE = 2;
Const CCC_ONEBK = 3;
Const CCC_BARHORZ = 4;
Const CCC_BKGND = 5;
Const CCC_2DBK = 6;
Const CCC_3DBK = 7;

Const CCS_LEGEND = 0;
Const CCS_SERLEGEND = 1;

Const CCP_SERIE = 0;
Const CCP_ONE = 1;

{ Gallery Types }
Const LINES = 1;
Const BAR = 2;
Const SPLINE = 3;
Const MARK = 4;
Const PIE = 5;
Const AREA = 6;
Const PARETO = 7;
Const SCATTER = 8;
Const HILOW = 9;

{ Chart Types }
Const CT_3D = $00000100;
Const CT_HORZ = $00000200;
Const CT_TOOL = $00000400;
Const CT_PALETTE = $00000800;
Const CT_LEGEND = $00001000;
Const CT_TOGETHER = $00002000;
Const CT_POINTS = $00004000;
Const CT_SHOWZERO = $00008000;
Const CT_EACHBAR = $00010000;
Const CT_CLUSTER = $00020000;
Const CT_SHOWDATA = $00040000;
Const CT_DLGGRAY = $00080000;
Const CT_PATTERN = $00100000;
Const CT_SHOWVALUES = $00200000;
Const CT_MENU = $00400000;
Const CT_SCATTERLINE	= $00800000;
Const CT_COLORLINE =	$01000000;
Const CT_NOAREALINE = $02000000;
Const CT_NOBORDERS = $04000000;
Const CT_PIEVALUES = $08000000;

{ Chart Styles }
Const CS_CHLINE = $00000001;
Const CS_CHBAR = $00000002;
Const CS_CHSPLINE = $00000004;
Const CS_CHMARK = $00000008;
Const CS_CHPIE = $00000010;
Const CS_CHAREA = $00000020;
Const CS_CHPARETO = $00000040;
Const CS_CHSCATTER = $00000080;
Const CS_CHHILOW = $00000100;
Const CS_CHDEFAULT = $00000FFF;
Const CS_MINMAX = $00001000;
Const CS_3D = $00002000;
Const CS_HORZ = $00004000;
Const CS_TOGETHER = $00008000;
Const CS_SHOWPOINT = $00010000;
Const CS_SCALE = $00020000;
Const CS_TITLES = $00040000;
Const CS_FONTS = $00080000;
Const CS_EDITABLE = $00100000;
Const CS_FILEEXPORT = $00200000;
Const CS_FILEIMPORT = $00400000;
Const CS_SCROLLABLE = $00800000;
Const CS_PRINTABLE = $01000000;
Const CS_3DVIEW = $02000000;
Const CS_GRID = $04000000;
Const CS_RESIZEABLE = $08000000;
Const CS_TEMPLATE = $10000000;
Const CS_COPY = $20000000;
Const CS_CLOSEABLE = $40000000;
Const CS_ALL = $FFFFFFFF;

{ Constants }

{ STYLE, TYPE }
Const CHART_ADD = 0;
Const CHART_SET = 1;
Const CHART_REMOVE = 2;

{ STACKED }
Const CHART_NOSTACKED = 0;
Const CHART_STACKED = 1;
Const CHART_STACKED100 = 2;

{ GRID }
Const CHART_NOGRID = 0;
Const CHART_HORZGRID = 1;
Const CHART_VERTGRID = 2;
Const CHART_BOTHGRID = 3;

{ POINTTYPE }
Const CHART_NONEMK = 0;
Const CHART_RECTMK = 1;
Const CHART_CIRCLEMK = 2;
Const CHART_TRIANGLEMK = 3;
Const CHART_MARBLEMK = 4;
Const CHART_CUBEMK = 5;
Const CHART_MANYMK = 6;

{ TITLES }
Const CHART_LEFTTIT = 0;
Const CHART_RIGHTTIT = 1;
Const CHART_TOPTIT = 2;
Const CHART_BOTTOMTIT = 3;

{ FONTS }
Const CHART_LEFTFT = 0;
Const CHART_RIGHTFT = 1;
Const CHART_TOPFT = 2;
Const CHART_BOTTOMFT = 3;
Const CHART_XLEGFT = 4;
Const CHART_YLEGFT = 5;
Const CHART_FIXEDFT = 6;
Const CHART_LEGENDFT = 7;

{ Types of DBLCLK o RIGCLK }
Const CHART_BALOONCLK = 0;
Const CHART_DIALOGCLK = 1;
Const CHART_NONECLK = 2;
Const CHART_MENUCLK = 3;

{ GAP }
Const CHART_LEFTGAP = 0;
Const CHART_RIGHGAP = 1;
Const CHART_TOPGAP = 2;
Const CHART_BOTTOMGAP = 3;
Const CHART_ALLGAP = 4;

{ Colors }
Const CHART_WHITE = 1;
Const CHART_BLACK = 2;
Const CHART_LTGRAY = 3;
Const CHART_DKGRAY = 4;
Const CHART_RED = 5;
Const CHART_DKRED = 6;
Const CHART_BLUE = 7;
Const CHART_DKBLUE = 8;
Const CHART_GREEN = 9;
Const CHART_DKGREEN = 10;
Const CHART_CYAN = 11;
Const CHART_DKCYAN = 12;
Const CHART_YELLOW = 13;
Const CHART_DKYELLOW = 14;
Const CHART_VIOLET = 15;
Const CHART_DKVIOLET = 16;

{ Line Styles }
Const CHART_SOLID = 0;
Const CHART_DASH = 1;
Const CHART_DOT = 2;
Const CHART_DASHDOT = 3;
Const CHART_DASHDOTDOT = 4;

{ Color Schemes }
Const CHART_CSSOLID = 0;
Const CHART_CSBWPATTERN = 1;
Const CHART_CSPATTERN = 2;

{ Color Types }
Const CHART_FGROUND = 0;
Const CHART_BGROUND = 1;

{ ChartStatus Property constants }
Const CHART_GSVALUES = $00000001;
Const CHART_GSLEGENDS = $00000002;
Const CHART_GSCOLORS = $00000004;
Const CHART_GSPATTERNS = $00000008;
Const CHART_GSPALETTE = $00000010;
Const CHART_GSPATTPAL = $00000020;
Const CHART_GSREADTEMP = $00000040;
Const CHART_GSREADFILE = $00000080;
Const CHART_GSGALLERY = $00000100;
Const CHART_GSOPTIONS = $00000200;

{ FONTS }
Const CF_BOLD = $00000100;
Const CF_ITALIC = $00000200;
Const CF_UNDERLINE = $00000400;
Const CF_STRIKEOUT = $00000800;
Const CF_FDONTCARE = $00000000;
Const CF_FROMAN = $00001000;
Const CF_FSWISS = $00002000;
Const CF_FMODERN = $00003000;
Const CF_FSCRIPT = $00004000;
Const CF_FDECORATIVE = $00005000;
Const CF_ARIAL = $00000000;
Const CF_COURIER = $00010000;
Const CF_COURIERNEW = $00020000;
Const CF_HELVETICA = $00030000;
Const CF_MODERN = $00040000;
Const CF_ROMAN = $00050000;
Const CF_SCRIPT = $00060000;
Const CF_SYMBOL = $00070000;
Const CF_TIMES = $00080000;
Const CF_TIMESNEWR = $00090000;
Const CF_WINGDINGS = $000A0000;

{ OpenData indexes }
Const COD_VALUES = 1;
Const COD_CONSTANTS = 2;
Const COD_COLORS = 3;
Const COD_STRIPES = 4;
Const COD_INIVALUES = 5;
Const COD_XVALUES = 6;
Const COD_STATUSITEMS = 7;

{ Closedata actions }
Const COD_SMOOTH = $1000;
Const COD_UNKNOWN = $FFFF;
Const COD_UNCHANGE = 0;

{ Adm indexes }
Const CSA_MIN = 0;
Const CSA_MAX = 1;
Const CSA_GAP = 2;
Const CSA_SCALE = 3;
Const CSA_YLEGGAP = 4;
Const CSA_PIXXVALUE = 5;
Const CSA_XMIN = 6;
Const CSA_XMAX = 7;
Const CSA_XGAP = 8;

{ XLEGTYPE }
Const CL_NOTCLIPPED = $0001;
Const CL_NOTCHANGECOLOR = $0002;
Const CL_HIDE = $0004;
Const CL_FORCESERLEG = $0008;
Const CL_GETLEGEND = $0010;
Const CC_HIDETEXT = $0001;
Const CC_HIDE = $0002;

{ ITEM[STYLE | COLOR | WIDTH] }
Const CI_HORZGRID = 0;
Const CI_VERTGRID = 1;

{ DECIMALSNUM }
Const CD_ALL = 0;
Const CD_VALUES = 1;
Const CD_YLEG = 2;
Const CD_XLEG = 3;

{ SHOWDIALOG }
Const CDIALOG_EXPORTFILE = 14;
Const CDIALOG_IMPORTFILE = 15;
Const CDIALOG_WRITETEMPLATE = 8;
Const CDIALOG_READTEMPLATE = 9;
Const CDIALOG_PAGESETUP = 4;
Const CDIALOG_ABOUT = 11;
Const CDIALOG_OPTIONS = 12;
Const CDIALOG_EDITTITLES = 35;
Const CDIALOG_FONTS = 39;
Const CDIALOG_ROTATE = 52;

{ StatusBar Item Structure }
Type CHART_STITEM = RECORD
	sText   : String;
	wIdm    : Integer;
	bFrame  : Integer;
	nWidth  : Integer;
	nMin    : Integer;
	nDesp   : Integer;
	dwStyle : LongInt;
     end;

{ Status Item Styles }
Const CHART_STLEFT = $0000;
Const CHART_STCENTER = $0001;
Const CHART_STRIGHT = $0002;

{ HILOW Constants }
Const HLC_HIGH = 0;
Const HLC_CLOSE = 1;
Const HLC_LOW = 2;

Const OHLC_CLOSE = 0;
Const OHLC_HIGH = 1;
Const OHLC_OPEN = 2;
Const OHLC_LOW = 3;

{ SetTool Constants }
Const CST_IMPORT = $00000001;
Const CST_EXPORT = $00000002;
Const CST_COPYBITMAP = $00000004;
Const CST_COPYDATA = $00000008;
Const CST_PRINT = $00000010;
Const CST_SPACE1 = $00000020;
Const CST_AREA = $00000040;
Const CST_BARHORZ = $00000080;
Const CST_BAR = $00000100;
Const CST_LINE = $00000200;
Const CST_MARK = $00000400;
Const CST_PIE = $00000800;
Const CST_SPLINE = $00001000;
Const CST_PARETO = $00002000;
Const CST_SCATTER = $00004000;
Const CST_HILOW = $00008000;
Const CST_SPACE2 = $00010000;
Const CST_3D = $00020000;
Const CST_ROTATE = $00040000;
Const CST_CLUSTER = $00080000;
Const CST_SPACE3 = $00100000;
Const CST_LEGEND = $00200000;
Const CST_VGRID = $00400000;
Const CST_HGRID = $00800000;
Const CST_SPACE4 = $01000000;
Const CST_TITLES = $02000000;
Const CST_FONTS = $04000000;
Const CST_TOOLS = $08000000;
Const CST_OPTIONS = $10000000;
Const CST_FILE = (CST_IMPORT Or CST_EXPORT);
Const CST_COPY = (CST_COPYBITMAP Or CST_COPYDATA);
Const CST_FILEEDIT = (CST_FILE Or CST_COPY Or CST_PRINT);
Const CST_GALLERY = (CST_AREA Or CST_BARHORZ Or CST_BAR Or CST_LINE Or CST_MARK Or CST_PIE Or CST_SPLINE);
Const CST_GALLERYEXT = (CST_GALLERY Or CST_PARETO Or CST_SCATTER Or CST_HILOW);
Const CST_VIEW = (CST_3D Or CST_ROTATE Or CST_CLUSTER);
Const CST_LEGGRID = (CST_LEGEND Or CST_VGRID Or CST_HGRID);
Const CST_OTHER = (CST_TITLES Or CST_FONTS Or CST_TOOLS Or CST_OPTIONS);

implementation

end.
